<?php 

include "properties.php";

// default values
$form = array(
	'sourcedsnid'		=> 'all',
	'neighbordsnid'		=> 'all',
	'state'		   		=> 'all',
	'timefrom'  		=> '0000-00-00 00:00:00',
	'timetill'   		=> '9999-12-31 00:00:00',
	'maxReply'			=> '10');
	
if(isset($_POST['_send_test'])){
	foreach($_POST as $key => $value){
		$form[$key] = htmlentities($_POST[$key]);
	}
//		header ("Content-Type: application/vnd.ms-excel");
//		header("Expires: 0");
//		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
//		header("content-disposition: attachment;filename==yourFileName.xls");
 
	show_form();
	show_log();
}
else{
	show_form();
}



function show_form(){
$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
$u=array();
$u[] = new xmlrpcval("1", "int");

$f=new xmlrpcmsg('getDSN.getDSN',$u);
// send request
$r=&$c->send($f);

// check response for errors, and take appropriate action
// draw the dots into the image
if (!$r->faultCode()) {
  $v=$r->value();
  $max=$v->arraysize();
  for($i=0; $i<$max; $i++) {
  		// change the data from the XmlRpc-Request into new vars
		$rec=$v->arraymem($i);
		$DSNID_temp		  = $rec->structmem("DSNID");
		$DSNID[$i] 		  = $DSNID_temp->scalarval();
  }
} else {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
}

?>
<hr/>
<form method="post" action="<?php echo $_SERVER['PHP_SELF']."?act=GetConinfo";?>">
<table> 
<tr><td>Source:</td><td>
	<select name="sourcedsnid">
	  <option><?php echo $GLOBALS['form']['sourcedsnid'];?></option>
	  <option>all</option>
<?php
for($i=0; $i<$max; $i++) {
	print '	  <option>'.$DSNID[$i].'</option>';
}
?>
	</select>
</td></tr>
<tr><td>Neighbor:</td><td>
	<select name="neighbordsnid">
	  <option><?php echo $GLOBALS['form']['neighbordsnid'];?></option>
	  <option>all</option>
<?php
for($i=0; $i<$max; $i++) {
	print '	  <option>'.$DSNID[$i].'</option>';
}
?>
	</select>
</td></tr>
<tr><td>state:</td><td>	
	<select name="maxReply">
	  <option><?php echo $GLOBALS['form']['state'];?></option>
	  <option>all</option>
	  <option>2</option>
	  <option>1</option>
	  <option>0</option>
	</select>
</td></tr>
<tr><td>timefrom:</td><td><input type="text" name="levelmask" value="<?php echo $GLOBALS['form']['timefrom'];?>"/></td></tr>
<tr><td>timetill:</td><td><input type="text" name="logtext" value="<?php echo $GLOBALS['form']['timetill'];?>"/></td></tr>
<tr><td>maxReply:</td><td>
	<select name="maxReply">
	  <option><?php echo $GLOBALS['form']['maxReply'];?></option>
	  <option>10</option>
	  <option>20</option>
	  <option>50</option>
	  <option>100</option>
	  <option>200</option>
	  <option>500</option>
	  <option>1000</option>
	</select>
</td></tr>
</table>
<input type="submit" value="get coninfo">
<input type="hidden" name="_send_test" value="1">
</form>
<hr/>
<?php

}


function show_log(){
	// create client and message objects
	$v=array();
	$v[] = new xmlrpcval($GLOBALS['form']['sourcedsnid'], "string"); // dsnid
	$v[] = new xmlrpcval($GLOBALS['form']['neighbordsnid'], "string"); // levelmask
	$v[] = new xmlrpcval($GLOBALS['form']['state'], "string");  // logclasses
	$v[] = new xmlrpcval($GLOBALS['form']['timefrom'], "string");  // timefrom
	$v[] = new xmlrpcval($GLOBALS['form']['timetill'], "string");  // timetil
	$v[] = new xmlrpcval($GLOBALS['form']['maxReply'], "int");  // timetil

	
	$f=new xmlrpcmsg('getConinfo.getConinfo',  $v);
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	
	// send request
	//print "<hr/><pre>".htmlentities($f->serialize())."</pre><hr/>\n";
	
	$r=&$c->send($f); 
	
	//print "<hr/><pre>".htmlentities($r->serialize())."</pre><hr/>\n";
	
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}
	else{
		$v = $r->value(); // array
		$max = $v->arraysize();
		if($max == 0){
			print "no entries found.\n";
			return;
		}
	?>
<style type="text/css">
	@import "getconinfo.css";
</style>
<?php
//header ("Content-Type: application/vnd.ms-excel");
//header("Expires: 0");
//header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
//header("content-disposition: attachment;filename==yourFileName.xls");
?>
	  <table class="log">
	    <tr>
	      <th>Time</th><th>Source</th><th>Neighbor</th><th>State</th><th>rssi</th>
	    </tr>  	
	<?php
		for($i=0; $i < $max; $i++){
			$rec = $v->arraymem($i); // struct
			$time_temp = $rec->structmem("time");
			$time = $time_temp->scalarval();
			$source_temp = $rec->structmem("SourceAddr");
			$source = $source_temp->scalarval();
			$neighbor_temp = $rec->structmem("NeighborAddr");
			$neighbor = $neighbor_temp->scalarval();
			$state_temp = $rec->structmem("State");
			$state = $state_temp->scalarval();
			$rssi_temp = $rec->structmem("rssi");
			$rssi = $rssi_temp->scalarval();
			print "<tr><td>".htmlspecialchars($time).
				  "</td><td>".htmlspecialchars($source).
			      "</td><td>".htmlspecialchars($neighbor).
			      "</td><td>".htmlspecialchars($state).
			      "</td><td>".htmlspecialchars($rssi).
			      "</td></tr>\n";
		}
		print "</table>\n";
	}
}
?>
