<?php

$v=array();
$v[] = new xmlrpcval();

//The Code below is now in the index.php file. 
//There we do the XMLRPC request and load the page
//index.php?act=GetDSN again, therefore the 
//page can be reloaded every 60 seconds whithout 
//sending the form again, otherwise the form will 
//be sent by every reload of the page.
////set Location
//if (isset($_POST["_send_coordinat"])){
//	
//	// create client and message objects
//	$location = $_POST["coordx"]."/".$_POST["coordy"]."/".$_POST["coordz"];
//	$v=array();
//	$v[] = new xmlrpcval($_POST["dsnid"], "string"); 
//	$v[] = new xmlrpcval($location, "string"); 
//
//	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
//	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
//	//$c->setDebug(2);
//	$f=new xmlrpcmsg('setDSNLocation.setDSNLocation',  $v);
//	
//	// send request
//	//print "<hr/><pre>".htmlentities($f->serialize())."</pre><hr/>\n";
//	
//	$r=&$c->send($f); 
//	
//	//print "<hr/><pre>".htmlentities($r->serialize())."</pre><hr/>\n";
//	//sleep(3);
//	if ($r->faultCode()) {
//	  print "An error occurred:<pre>";
//	  print "Code: " . htmlspecialchars($r->faultCode()) .
//		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
//	}
//}




// draw the DSNLocation into the image
// XmlRpc Server
$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
// XmlRpc Function
$lasttime = "";
$req = new xmlrpcmsg('getServerTime.getServerTime');
$resp = $c->send($req);
if(!$resp->faultCode()){
	$servertime = $resp->value()->scalarval();
	$lasttime = strtotime($servertime);
//	$ftime = strptime($servertime, '%Y-%m-%d %T');
//	$lasttime = mktime(                        
//		$ftime['tm_hour'],
//	        $ftime['tm_min'],
//	        $ftime['tm_sec'],
//	        1,
//	        $ftime['tm_yday'] + 1,
//	        $ftime['tm_year'] + 1900);
	$lasttime -= $GLOBALS['pingInterval'];
	$lasttime = date('Y-m-d H:i:s', $lasttime);
}                                                                                     


if(isset($_GET['order'])) {	
	$order = $_GET['order'];
} 
else {$order = 0;}

$u=array();
$u[] = new xmlrpcval($order, "int");

$f=new xmlrpcmsg('getDSN.getDSN',$u);
// send request
//$c->setDebug(2);
$r=&$c->send($f);

// check response for errors, and take appropriate action
// draw the dots into the image
if (!$r->faultCode()) {
  $v=$r->value();
  $max=$v->arraysize();
  $DSNLocation = array();
  $location = array();
  $DSNLocation_x = array();
  $DSNLocation_y = array();
  $DSNLocation_z = array();
  for($i=0; $i<$max; $i++) {
  		// change the data from the XmlRpc-Request into new vars
		$rec=$v->arraymem($i);
		$DSNID_temp		  = $rec->structmem("DSNID");
		$DSNID[$i] 		  = $DSNID_temp->scalarval();
		$DSNBootCount_temp  = $rec->structmem("BootCount");
		$DSNBootCount[$i]   = $DSNBootCount_temp->scalarval();
		$DSNVer_temp	  = $rec->structmem("DSNVer");
		$DSNVer[$i] 	  = $DSNVer_temp->scalarval();
		$DSNLocation_temp = $rec->structmem("DSNLocation");
		$DSNLocation[$i]  = $DSNLocation_temp->scalarval();
		$DSNProgInfo_temp = $rec->structmem("DSNProgInfo");
		$DSNProgInfo[$i]  = $DSNProgInfo_temp->scalarval();
		$DSNlastSeen_temp = $rec->structmem("DSNlastSeen");
		$DSNlastSeen[$i]  = $DSNlastSeen_temp->scalarval();
		$NodeInfo_temp 	  = $rec->structmem("NodeInfo");
		$NodeInfo[$i]  = $NodeInfo_temp->scalarval();
		// a hashtable to indicate the DSNId to the number $i (is used for drawing the conection arrows)
		$DSNIDtoNum[$DSNID[$i]] = $i;
		// parse the location string (xxx/yyy/zzz is espected)
		$firstbackslash = strpos($DSNLocation[$i],"/");
		if ($firstbackslash != false) {$lastbackslash = strpos($DSNLocation[$i],"/",$firstbackslash+1);}
		if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_x[$i] = substr($DSNLocation[$i], 0,$firstbackslash);$location[$i] = true;} else{$DSNLocation_x[$i] = 0;$location[$i] = false;}
		if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_y[$i] = substr($DSNLocation[$i], $firstbackslash+1,$lastbackslash-($firstbackslash+1));;} else{$DSNLocation_y[$i] = 0;}
		if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_z[$i] = substr($DSNLocation[$i], $lastbackslash+1, strlen($DSNLocation[$i])-($lastbackslash+1));;} else{$DSNLocation_z[$i] = 0;}

  }
} else {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
}

print'
<style type="text/css">
	@import "getdsn.css";
</style>
<script type="text/javascript">
		

// always start auto-refresh onLoad
var RefreshID = setInterval("window.location.reload()",300000);

function StopRefresh(){
clearInterval(RefreshID);
}

function RestartRefresh(){
RefreshID = setInterval("window.location.reload()",300000);
}

function edit (DSNID,Location) {
  if (document.getElementById){
    document.getElementById("edit_"+DSNID).style.display = "none";
    document.getElementById("form_"+DSNID).style.display = "inline";
	StopRefresh();
  }
}

function cancel (DSNID,Location) {
  if (document.getElementById){
    document.getElementById("edit_"+DSNID).style.display = "inline";
    document.getElementById("form_"+DSNID).style.display = "none";
    RestartRefresh();
  }
}

function edit_ni (DSNID,Location) {
  if (document.getElementById){
    document.getElementById("edit_ni_"+DSNID).style.display = "none";
    document.getElementById("form_ni_"+DSNID).style.display = "inline";
	StopRefresh();
  }
}

function cancel_ni (DSNID,Location) {
  if (document.getElementById){
    document.getElementById("edit_ni_"+DSNID).style.display = "inline";
    document.getElementById("form_ni_"+DSNID).style.display = "none";
    RestartRefresh();
  }
}

</script>

<br><br>
<table class="log">
<tr>
  <th>';
		if (isset($_GET['order']) && $_GET['order']==1){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=2" onmouseover="if(document.getElementById(\'soimg1\')){ document.getElementById(\'soimg1\').src=\'s_desc.png\'; }" onmouseout="if(document.getElementById(\'soimg1\')){ document.getElementById(\'soimg1\').src=\'s_asc.png\'; }" title="Sort">DSNID <img class="icon" src="s_asc.png" border=0 width="11" height="9" alt="Ascending" title="Ascending" id="soimg1" /></th>';}
		else if (isset($_GET['order']) && $_GET['order']==2){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=1" onmouseover="if(document.getElementById(\'soimg1\')){ document.getElementById(\'soimg1\').src=\'s_asc.png\'; }" onmouseout="if(document.getElementById(\'soimg1\')){ document.getElementById(\'soimg1\').src=\'s_desc.png\'; }" title="Sort">DSNID <img class="icon" src="s_desc.png" border=0 width="11" height="9" alt="Descending" title="Descending" id="soimg1" /></th>';}
  		else {print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=1">DSNID</a>';}
print'</th><th>BootCount</th><th>';		
		if (isset($_GET['order']) && $_GET['order']==3){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=4" onmouseover="if(document.getElementById(\'soimg2\')){ document.getElementById(\'soimg2\').src=\'s_desc.png\'; }" onmouseout="if(document.getElementById(\'soimg2\')){ document.getElementById(\'soimg2\').src=\'s_asc.png\'; }" title="Sort">DSNVersion <img class="icon" src="s_asc.png" border=0 width="11" height="9" alt="Ascending" title="Ascending" id="soimg2" /></th>';}
		else if (isset($_GET['order']) && $_GET['order']==4){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=3" onmouseover="if(document.getElementById(\'soimg2\')){ document.getElementById(\'soimg2\').src=\'s_asc.png\'; }" onmouseout="if(document.getElementById(\'soimg2\')){ document.getElementById(\'soimg2\').src=\'s_desc.png\'; }" title="Sort">DSNVersion <img class="icon" src="s_desc.png" border=0 width="11" height="9" alt="Descending" title="Descending" id="soimg2" /></th>';}
  		else {print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=3">DSNVersion</a>';}
print'</th><th>';		
		if (isset($_GET['order']) && $_GET['order']==5){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=6" onmouseover="if(document.getElementById(\'soimg3\')){ document.getElementById(\'soimg3\').src=\'s_desc.png\'; }" onmouseout="if(document.getElementById(\'soimg3\')){ document.getElementById(\'soimg3\').src=\'s_asc.png\'; }" title="Sort">DSNLocation <img class="icon" src="s_asc.png" border=0 width="11" height="9" alt="Ascending" title="Ascending" id="soimg3" /></th>';}
		else if (isset($_GET['order']) && $_GET['order']==6){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=5" onmouseover="if(document.getElementById(\'soimg3\')){ document.getElementById(\'soimg3\').src=\'s_asc.png\'; }" onmouseout="if(document.getElementById(\'soimg3\')){ document.getElementById(\'soimg3\').src=\'s_desc.png\'; }" title="Sort">DSNLocation <img class="icon" src="s_desc.png" border=0 width="11" height="9" alt="Descending" title="Descending" id="soimg3" /></th>';}
  		else {print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=5">DSNLocation</a>';}
print'</th><th>';		
		if (isset($_GET['order']) && $_GET['order']==7){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=8" onmouseover="if(document.getElementById(\'soimg4\')){ document.getElementById(\'soimg4\').src=\'s_desc.png\'; }" onmouseout="if(document.getElementById(\'soimg4\')){ document.getElementById(\'soimg4\').src=\'s_asc.png\'; }" title="Sort">DSNProgInfo <img class="icon" src="s_asc.png" border=0 width="11" height="9" alt="Ascending" title="Ascending" id="soimg4" /></th>';}
		else if (isset($_GET['order']) && $_GET['order']==8){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=7" onmouseover="if(document.getElementById(\'soimg4\')){ document.getElementById(\'soimg4\').src=\'s_asc.png\'; }" onmouseout="if(document.getElementById(\'soimg4\')){ document.getElementById(\'soimg4\').src=\'s_desc.png\'; }" title="Sort">DSNProgInfo <img class="icon" src="s_desc.png" border=0 width="11" height="9" alt="Descending" title="Descending" id="soimg4" /></th>';}
  		else {print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=7">DSNProgInfo</a>';}
print'</th><th>';		
		if (isset($_GET['order']) && $_GET['order']==9){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=10" onmouseover="if(document.getElementById(\'soimg5\')){ document.getElementById(\'soimg5\').src=\'s_desc.png\'; }" onmouseout="if(document.getElementById(\'soimg5\')){ document.getElementById(\'soimg5\').src=\'s_asc.png\'; }" title="Sort">DSNlastSeen <img class="icon" src="s_asc.png" border=0 width="11" height="9" alt="Ascending" title="Ascending" id="soimg5" /></th>';}
		else if (isset($_GET['order']) && $_GET['order']==10){print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=9" onmouseover="if(document.getElementById(\'soimg5\')){ document.getElementById(\'soimg5\').src=\'s_asc.png\'; }" onmouseout="if(document.getElementById(\'soimg5\')){ document.getElementById(\'soimg5\').src=\'s_desc.png\'; }" title="Sort">DSNlastSeen <img class="icon" src="s_desc.png" border=0 width="11" height="9" alt="Descending" title="Descending" id="soimg5" /></th>';}
  		else {print'<a style="color:black;" href="'.$_SERVER['PHP_SELF'].'?act=GetDSN&order=9">DSNlastSeen</a>';}
print'</th><th>NodeInfo</th></th>';		
print'</tr> '; 	

function isold($lastseen){
	global $lasttime, $oldcount;
	if($lastseen < $lasttime){
		$oldcount++;
		return(' class="old"');
	}
	else return('');
}

$progcolors=Array('#FFFFFF','#FFDDDD','#DDFFDD','#DDDDFF','#DDFFFF','#FFDDFF','#FFFFDD','#EEAAFF','#FFEEAA');
$oldcount = 0;
$progcounter=1;
$progs[0]='NP';
for($i=0; $i < $max; $i++){
	$found=FALSE;
	for($l=0;$l<$progcounter;$l++) {
		if ($progs[$l]==$DSNProgInfo[$i]) {
			$progcolor=$l;	
			$found=TRUE;
		}
	}
	if (!$found) {
		$progcolor=$progcounter;
		$progs[$progcounter++]=$DSNProgInfo[$i];
	}
	print "<tr".isold($DSNlastSeen[$i])."><td>".htmlspecialchars($DSNID[$i]).
		  "</td><td>".htmlspecialchars($DSNBootCount[$i]).
		  "</td><td>".htmlspecialchars($DSNVer[$i]).
		  "</td><td>";
	if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["SetLocation"])){
		print'<div id="edit_'.htmlspecialchars($DSNID[$i]).'" style="display:inline;"><a href="javascript:edit(\''.htmlspecialchars($DSNID[$i]).'\',\''.htmlspecialchars($DSNLocation[$i]).'\')"><img src="b_edit.png" border=0 alt="Edit" title="Edit"/></a>'.htmlspecialchars($DSNLocation[$i]).'</div>';
		print'<div id="form_'.htmlspecialchars($DSNID[$i]).'" style="display:none;"><form id="formular_'.htmlspecialchars($DSNID[$i]).'" method="post"><input type="text" size="1" name="coordx" value="'.$DSNLocation_x[$i].'" style="margin-left:0px; font-size:8pt; border:1px outset #000000;"/>/<input type="text" size="1" name="coordy" value="'.$DSNLocation_y[$i].'"  style="margin-left:0px; font-size:8pt; border:1px outset #000000;"/>/<input type="text" size="1" name="coordz" value="'.$DSNLocation_z[$i].'"  style="margin-left:0px; font-size:8pt; border:1px outset #000000;"/><input type="hidden" name="_send_coordinat" value="1"><input type="hidden" name="dsnid" value="'.$DSNID[$i].'">&nbsp<a href="javascript:document.getElementById(\'formular_'.htmlspecialchars($DSNID[$i]).'\').submit();"><img src="s_okay.png" border=0 alt="okay" title="okay"/></a>&nbsp<a href="javascript:cancel(\''.htmlspecialchars($DSNID[$i]).'\',\''.htmlspecialchars($DSNLocation[$i]).'\')"><img src="s_error.png" border=0 alt="cancel" title="cancel"/></a></form></div>';
	}
	else {print htmlspecialchars($DSNLocation[$i]);}
	if ($DSNProgInfo[$i]!="NP"){print"</td><td style=\"background-color:".$progcolors[$progcolor]."\">".htmlspecialchars($DSNProgInfo[$i]);}
	else {print "</td><td>".htmlspecialchars($DSNProgInfo[$i]);}
	print "</td><td>".htmlspecialchars($DSNlastSeen[$i]);
	print "</td><td>";
	if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["SetLocation"])){
		print'<div id="edit_ni_'.htmlspecialchars($DSNID[$i]).'" style="display:inline;"><a href="javascript:edit_ni(\''.htmlspecialchars($DSNID[$i]).'\',\''.htmlspecialchars($DSNLocation[$i]).'\')"><img src="b_edit.png" border=0 alt="Edit" title="Edit"/></a>'.htmlspecialchars($NodeInfo[$i]).'</div>';
		print'<div id="form_ni_'.htmlspecialchars($DSNID[$i]).'" style="display:none;"><form id="formular_ni_'.htmlspecialchars($DSNID[$i]).'" method="post"><input type="text" size="10" name="NodeInfo" value="'.$NodeInfo[$i].'" style="margin-left:0px; font-size:8pt; border:1px outset #000000;"/><input type="hidden" name="_send_nodeinfo" value="1"><input type="hidden" name="dsnid" value="'.$DSNID[$i].'">&nbsp<a href="javascript:document.getElementById(\'formular_ni_'.htmlspecialchars($DSNID[$i]).'\').submit();"><img src="s_okay.png" border=0 alt="okay" title="okay"/></a>&nbsp<a href="javascript:cancel_ni(\''.htmlspecialchars($DSNID[$i]).'\',\''.htmlspecialchars($DSNLocation[$i]).'\')"><img src="s_error.png" border=0 alt="cancel" title="cancel"/></a></form></div>';
	}
	else {print htmlspecialchars($NodeInfo[$i]);}
	print "</td></tr>";
}
$activecount = $max-$oldcount;
print("<p><br/>$activecount of $max nodes active.</p>");

print'</table>';

?>
