<?php
	include("xmlrpc.inc");
	include ("properties.php");

function execute_l($thread, $state){
	$v=array();
	$v[] = new xmlrpcval($thread, "string"); 
	$v[] = new xmlrpcval($state, "string"); 

	$f=new xmlrpcmsg('threadSwitch.threadSwitch',  $v);
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
	//$c->setDebug(2);
	
	$r=&$c->send($f); 
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}

}

function sendping_l($string, $destination = 'all'){
	$v=array();
	$v[] = new xmlrpcval($destination, "string"); 
	$v[] = new xmlrpcval($string, "string"); 

	$f=new xmlrpcmsg('dsnCommand.dsnCommand',  $v);
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
	//$c->setDebug(2);
	
	$r=&$c->send($f); 
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}	
}



	session_start();

  	if(isset($_GET['act']) AND ("Logout" == $_GET['act'])) {
		session_unset();
        session_destroy();
		//Ausgeloggt
	}

	if (isset($_POST["Username"], $_POST["pwd"]))
	{

		$v=array();
		$v[] = new xmlrpcval($_POST["Username"], "string");  // username
		$v[] = new xmlrpcval(md5($_POST["pwd"]), "string");  // md5pwd
	
		
		$f=new xmlrpcmsg('user.user',  $v);
		$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
		
		// send request
		$r=&$c->send($f); 
		
		if ($r->faultCode()) {
		  print "An error occurred:<pre>";
		  print "Code: " . htmlspecialchars($r->faultCode()) .
			"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
		}
		else{
			$v = $r->value(); // array
			$max = $v->arraysize();
		}

		if ($max != 0) 
		{
			$_SESSION["Username"] = $_POST["Username"];
			$_SESSION["md5pwd"] = md5($_POST["pwd"]);					
			$_SESSION["pwd"] = $_POST["pwd"];					
			$_SESSION["IP"] = $_SERVER["REMOTE_ADDR"];
			
			for($i=0; $i < $max; $i++){
				$rec = $v->arraymem($i); // struct
				$function_temp = $rec->structmem("Function");
				$function = $function_temp->scalarval();
				$_SESSION[$function] = true;
			}
		}
	}
	
	
	
	
//If no formular is sent from the GetDSN Page it can take this normal header.
//Otherwise it should the appropriate acction an relaod the GetDSN site.
//Therefore the GetDSN site can be refreshed without sending the form data again.  
if(!((isset($_GET['act']) AND ("GetDSN" == $_GET['act'])) AND (isset($_POST["_send_coordinat"]) || isset($_POST['send_dsnping_l']) || isset($_POST['send_dsnversionping_l']) || isset($_POST['send_dsnlocationping_l']) || isset($_POST['send_dsnproginfoping_l']) || isset($_POST['send_coninfo_l']) || isset($_POST['_send_command_l']) || isset($_POST["_send_nodeinfo"])))) {
	print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">';
	print '<html><head><title>Deployment Support Network - Tool</title>';

	print'<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"';
	
	print'	</head>';
	print'<link rel="stylesheet" type="text/css" href="all.css">';
	print'<link rel="stylesheet" type="text/css" href="index.css">';
}
else if (isset($_POST["_send_coordinat"])){	
	// create client and message objects
	$location = $_POST["coordx"]."/".$_POST["coordy"]."/".$_POST["coordz"];
	$v=array();
	$v[] = new xmlrpcval($_POST["dsnid"], "string"); 
	$v[] = new xmlrpcval($location, "string"); 
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
	//$c->setDebug(2);
	$f=new xmlrpcmsg('setDSNLocation.setDSNLocation',  $v);
	$r=&$c->send($f); 
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}	
	header("Location: index.php?act=GetDSN");
	exit;
}
else if (isset($_POST["_send_nodeinfo"])){	
	// create client and message objects
	$v=array();
	$v[] = new xmlrpcval($_POST["dsnid"], "string"); 
	$v[] = new xmlrpcval($_POST["NodeInfo"], "string"); 
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
	//$c->setDebug(2);
	$f=new xmlrpcmsg('setNodeInfo.setNodeInfo',$v);
	$r=&$c->send($f); 
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}	
	header("Location: index.php?act=GetDSN");
	exit;
}	
else if(isset($_POST['send_dsnping_l'])){sendping_l("dsn ping");header("Location: index.php?act=GetDSN");exit;}
else if(isset($_POST['send_dsnversionping_l'])){sendping_l("dsn get version");header("Location: index.php?act=GetDSN");exit;}
else if(isset($_POST['send_dsnlocationping_l'])){sendping_l("dsn get loc");header("Location: index.php?act=GetDSN");exit;}
else if(isset($_POST['send_dsnproginfoping_l'])){sendping_l("xbank get proginfo");header("Location: index.php?act=GetDSN");exit;}
else if(isset($_POST['send_coninfo_l'])){sendping_l("coninfo","root");header("Location: index.php?act=GetDSN");exit;}
else if(isset($_POST['_send_command_l'])){
	if (($_POST["command"]!=" --write a command--") && ($_POST["command"]!="" )){
		$v=array();
		$v[] = new xmlrpcval($_POST["dsnid"], "string");
		$v[] = new xmlrpcval($_POST["command"], "string");  
		$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
	}
	else if ($_POST["precommand"]!="--or select a command!--"){
		$v=array();
		$v[] = new xmlrpcval($_POST["dsnid"], "string"); 
		$v[] = new xmlrpcval($_POST["precommand"], "string"); 
		$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
	}
	
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
	//$c->setDebug(2);
	$r=$c->send($f);
	
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}
	header("Location: index.php?act=GetDSN");exit;
}

?>
<body>
<div id="banner"><h1>Deployment Support Network Tool</h1></div>

<div id="leftcontent"> 
  <ul id="Navigation">
    <li><a href="<?php echo $_SERVER['PHP_SELF']."";?>">Home</a></li>
    <li><a href="<?php echo $_SERVER['PHP_SELF']."?act=GetDSN";?>">GetDSN</a></li>
    <li><a href="<?php echo $_SERVER['PHP_SELF']."?act=GetDBEvent";?>">GetDBEvent</a></li>
    <li><a href="<?php echo $_SERVER['PHP_SELF']."?act=GetConinfo";?>">GetConinfo</a></li>
    <li><a href="<?php echo $_SERVER['PHP_SELF']."?act=GetRPCS";?>">GetRPCS</a></li>
    <li> 
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["SetLocation"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=SetLocation">SetLocation</a>';} else {echo '<div>SetLocation</div>';} ?>
    </li>
    <li> 
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["SetVerbosity"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=SetVerbosity">SetVerbosity</a>';} else {echo '<div>SetVerbosity</div>';} ?>
    </li>
    <li> 
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["DSNCommand"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=DSNCommand">DSNCommand</a>';} else {echo '<div>DSNCommand</div>';} ?>
    </li>
    <li> 
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["LoadFile"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=LoadFile">LoadFile</a>';} else {echo '<div>LoadFile</div>';} ?>
    </li>
    <li> 
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["TargetCommand"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=TargetCommand">TargetCommand</a>';} else {echo '<div>TargetCommand</div>';} ?>
    </li>
    <!--
    <li>
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["TargetFlash"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=TargetFlash">TargetFlash</a>';} else {echo '<div>TargetFlash</div>';} ?>
    </li>
-->
    <!--
    <li>
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["UploadFile"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=UploadFile">UploadFile</a>';} else {echo '<div>UploadFile</div>';} ?>
    </li>
-->
    <!--
	<li>
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["GetServerTime"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=GetServerTime">GetServerTime</a>';} else {echo '<div>GetServerTime</div>';} ?>
    </li>
-->
    <li> 
      <?php if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["ThreadSwitch"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=ThreadSwitch">ThreadSwitch</a>';} else {echo '<div>ThreadSwitch</div>';} ?>
    </li>
    <li> 
      <?php if(isset($_SESSION["Username"])){echo '<a href="'.$_SERVER["PHP_SELF"].'?act=Logout">Logout</a>';} else {echo '<a href="'.$_SERVER["PHP_SELF"].'?act=Login">Login</a>';}?>
    </li>
  </ul>
</div>


<div id="leftcontentunder">
	<div id="normal"> 
	<?php

if((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["DSNCommand"])) 
		{	  
			print "shortcut commands";
			include "shortcutcommand.php";
		}			
	  ?>
	</div>
</div>


<div id="centercontent">
  <div id="normal"> 
    <?php
  	if(isset($_GET['act']) AND ("GetDSN" == $_GET['act'])) {
		print "GetDSN";
		include "showimg.php";
		include "getdsn.php";
	}
  	else if(isset($_GET['act']) AND ("GetDBEvent" == $_GET['act'])) { 
		print "GetDBEvent";
		include "getdbevent.php";
	}
  	else if(isset($_GET['act']) AND ("GetConinfo" == $_GET['act'])) { 
		print "GetConinfo";
		include "getconinfo.php";
	}
  	else if(isset($_GET['act']) AND ("GetRPCS" == $_GET['act'])) { 
		print "GetRPCS";
		include "getrpcs.php";
	}
  	else if(isset($_GET['act']) AND ("SetLocation" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["SetLocation"])) { 
		print "SetLocation";
		include "setlocation.php";
	}
  	else if(isset($_GET['act']) AND ("SetVerbosity" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["SetVerbosity"])) {
		print "SetVerbosity";
		include "setverbosity.php";	
	}
  	else if(isset($_GET['act']) AND ("DSNCommand" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["DSNCommand"])) { 
  		print "DSNCommand";
  		include "dsncommand.php";
  	}
  	else if(isset($_GET['act']) AND ("LoadFile" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["LoadFile"])) { 
		print "LoadFile";
		include "uploadfile.php";
	}
  	else if(isset($_GET['act']) AND ("TargetCommand" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["TargetCommand"])) { 
  		print "TargetCommand";
  		include "targetcommand.php";
  	}
  	else if(isset($_GET['act']) AND ("TargetGlash" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["TargetFlash"])) { print "TargetFlash";}
  	else if(isset($_GET['act']) AND ("UploadFile" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["UploadFile"])) { print "UploadFile<br>";	}
  	else if(isset($_GET['act']) AND ("GetServerTime" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["GetServerTime"])) { print "SetServerTime";}
  	else if(isset($_GET['act']) AND ("ThreadSwitch" == $_GET['act'])&&(isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["ThreadSwitch"])) { 
  		print "ThreadSwitch";
  		include "threadswitch.php";
  	}  	
  	else if(isset($_GET['act']) AND ("Login" == $_GET['act'])) { 
		print "Login";
		print'    <table width="410" border="2" cellspacing="0" cellpadding="0">
				  <form action="'.$_SERVER['PHP_SELF'].'" method="post">
					<tr> 
					  <td>Username: </td>
					  <td><input name="Username" type="text" size="20"></td>
					</tr>
					<tr> 
					  <td>Passwort: </td>
					  <td><input name="pwd" type="password" size="20"></td>
					</tr>
					<tr> 
					  <td rowspan="2"><input name="send" type="submit" value="Log in"></td>
					</tr>
				  </form>
				</table>
		';
	}
  	else if(isset($_GET['act']) AND ("Logout" == $_GET['act'])) { print "Logout";}
  	else { print "HOME";}
?>
  </div>
</div>

</body>
</html>
