<?php

include("properties.php");

set_time_limit(600);
ini_set("max_execution_time",600);
ini_set("max_input_time",600);

print'<hr/><br>';

upload();
load();
flash();

function display_error($r) {
	print "An error occurred: ";
	print "Code: " . $r->faultCode() .
		" Reason: '" .$r->faultString()."'<br/>";
}

function upload(){
	if(isset($_POST['_send_upload'])){
		//echo $_FILES['userfile']['error'];
		$handle = fopen($_FILES['userfile']['tmp_name'], "r");
		$contents = fread($handle, filesize($_FILES['userfile']['tmp_name']));
		fclose($handle);
		$encoded = chunk_split(base64_encode($contents));
	
		$v=array();
		$v[] = new xmlrpcval($_FILES['userfile']['name'], "string"); 
		$v[] = new xmlrpcval($encoded, "string"); 
	
		$f=new xmlrpcmsg('uploadFile.uploadFile', $v);
		$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
		$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
		//$c->setDebug(2);
		$r=$c->send($f);
		
		if ($r->faultCode()) {
		  print "An error occurred:<pre>";
		  print "Code: " . htmlspecialchars($r->faultCode()) .
			"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
		}
		else{
			$v = $r->value(); 
		}
	}
	
	
	print'
	<!-- The data encoding type, enctype, MUST be specified as below -->
	Upload a File to the Server.<br>
	<form enctype="multipart/form-data" action="'.$_SERVER['PHP_SELF'].'?act=LoadFile" method="POST">
		<!-- MAX_FILE_SIZE must precede the file input field -->
		<input type="hidden" name="MAX_FILE_SIZE" value="3000000" />
		<!-- Name of input element determines name in $_FILES array -->
		<input name="userfile" type="file" />
		<input type="hidden" name="_send_upload" value="1">
		<input type="submit" value="Send File" />
	</form>';
		if(isset($_POST['_send_test']) && $v->scalarval()!=""){ echo $v->scalarval()." has been uploaded.";}
		else if (isset($_POST['_send_test']) && $v->scalarval()==""){echo "An error occured.";}
	print'
	<hr/>
	<br>';	
}

function load(){

	if(isset($_POST['_send_load'])){
	
		$v=array();
		$v[] = new xmlrpcval($_POST['filename'], "string"); 
		$v[] = new xmlrpcval(substr($_POST['type'],0,1), "string"); 
		$f=new xmlrpcmsg('loadFile.loadFile', $v);
		$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
		$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
		//$c->setDebug(2);
		$r=$c->send($f);
		
		if ($r->faultCode()) {
		  print "An error occurred:<pre>";
		  print "Code: " . htmlspecialchars($r->faultCode()) .
			"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
		}
		else{
			$v = $r->value(); 
		}
	}

	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$f=new xmlrpcmsg('getFileList.getFileList');
	// send request
	$r=&$c->send($f);
	
	// check response for errors, and take appropriate action
	// draw the dots into the image
	if (!$r->faultCode()) {
	  $v=$r->value();
	  $max=$v->arraysize();
	  for($i=0; $i<$max; $i++) {
			// change the data from the XmlRpc-Request into new vars
			$rec=$v->arraymem($i);
			$Filename_temp		  = $rec->structmem("Filename");
			$Filename[$i] 		  = $Filename_temp->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}

	print'
	Load a File to the GUInode to distribute to the other nodes.
	<form method="post" action="'.$_SERVER['PHP_SELF'].'?act=LoadFile">
		<table> 
		<tr><td>File:</td><td>
			<select name="filename">
			  <option>-- Choose a File --</option>';
		for($i=0; $i<$max; $i++) {
			print '	  <option>'.$Filename[$i].'</option>';
		}
	print'
			</select>
		</td></tr>
		<tr><td>Type:</td><td>
			<select name="type">
			  <option>1 - reprogram target node</option>
			  <option>0 - reprogram dsn node</option>
			</select>
		</td></tr>
		<input type="hidden" name="_send_load" value="1">
		<tr><td></td></tr><tr><td><input type="submit" value="Load File" /></td></tr>
		</table>
	</form>
	<hr/>';
}

function flash(){
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$u=array();
	$u[] = new xmlrpcval("1", "int");

	$f=new xmlrpcmsg('getDSN.getDSN',$u);
	// send request
	$r=&$c->send($f);
	
	// check response for errors, and take appropriate action
	// draw the dots into the image
	if (!$r->faultCode()) {
	  $v=$r->value();
	  $max=$v->arraysize();
	  for($i=0; $i<$max; $i++) {
			// change the data from the XmlRpc-Request into new vars
			$rec=$v->arraymem($i);
			$DSNID_temp		  = $rec->structmem("DSNID");
			$DSNID[$i] 		  = $DSNID_temp->scalarval();
			$ProgInfo_temp		  = $rec->structmem("DSNProgInfo");
			$ProgInfo[$i] 		  = $ProgInfo_temp->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}

	if(isset($_POST['_send_flash'])){
		if (isset($_POST["all"])){
			if ($_POST["flash"]=="target"){
				$v=array();
				$v[] = new xmlrpcval("all", "string"); 
				$f=new xmlrpcmsg('targetFlash.targetFlash', $v);
			}
			if ($_POST["flash"]=="dsn"){
				$v=array();
				$v[] = new xmlrpcval("all", "string"); 
				$v[] = new xmlrpcval("reset", "string"); 
				$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
			}
			
			$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
			$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
			//$c->setDebug(2);
			$r=$c->send($f);
			
			if ($r->faultCode()) {
			  print "An error occurred:<pre>";
			  print "Code: " . htmlspecialchars($r->faultCode()) .
				"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
			}
			else{
				$v = $r->value(); 
			}
		}
		else{
			$f=array();
			$k=0;
			$DSNID_one="";
			for($i=0; $i<$max; $i++) {
				if (isset($_POST["ID".str_replace(":","",$DSNID[$i])])){
					if ($_POST["flash"]=="target"){
						$k++;
						$v = new xmlrpcval($_POST["ID".str_replace(":","",$DSNID[$i])], "string"); 
						$f[$k]=new xmlrpcmsg('targetFlash.targetFlash');
						$f[$k]->addParam($v);
						$DSNID_one = $_POST["ID".str_replace(":","",$DSNID[$i])]; //is used if there is only one DSN Addr selected
					}
					if ($_POST["flash"]=="dsn"){
						$k++;
						$v1 = new xmlrpcval($_POST["ID".str_replace(":","",$DSNID[$i])], "string"); 
						$v2 = new xmlrpcval("reset", "string"); 
						$f[$k]=new xmlrpcmsg('dsnCommand.dsnCommand');
						$f[$k]->addParam($v1);
						$f[$k]->addParam($v2);
						$DSNID_one = $_POST["ID".str_replace(":","",$DSNID[$i])]; //is used if there is only one DSN Addr selected						
					}
				}
			}
			if ($k==1){
				if ($_POST["flash"]=="target"){
					$v=array();
					$v[] = new xmlrpcval($DSNID_one, "string"); 
					$f=new xmlrpcmsg('targetFlash.targetFlash',$v);
				}
				if ($_POST["flash"]=="dsn"){
					$v=array();
					$v[] = new xmlrpcval($DSNID_one, "string"); 
					$v[] = new xmlrpcval("reset", "string"); 
					$f=new xmlrpcmsg('dsnCommand.dsnCommand',$v);
				}
			}
			$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
			$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
			//$c->setDebug(2);
			$r=&$c->send($f);
			//$r=$c->send($f);
			if ($k < 1){
				for($i=1; $i<=$k; $i++) {
					if ($r[$i]->faultCode()) {
						display_error($r[$i]);
					}
				}
			}else if ($k==1){
				if ($r->faultCode()) {
				  print "An error occurred:<pre>";
				  print "Code: " . htmlspecialchars($r->faultCode()) .
					"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
				}
			}
		}
	}

	if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["DSNCommand"]||$_SESSION["TargetFlash"])){
		print'
		<br>
		Flash a DSN node or a Target node.';
		print'
		<form method="post" action="'.$_SERVER['PHP_SELF'].'?act=LoadFile">';
		print '<table>';

		if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["TargetFlash"])){
		print '<tr><td colspan="3">&nbsp;target:<input name="flash" type="radio" value="target" checked>';}
		if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["DSNCommand"])){
		print '&nbsp;&nbsp;&nbsp;dsn:<input name="flash" type="radio" value="dsn" >';}
		print'
			<input type="hidden" name="_send_flash" value="1">
			&nbsp;<input type="submit" value="Flash" />
		  </td></tr>';				

		print '<tr><td><input name="all" type="checkbox" value="all"'; 
			print' onclick="';
				for($i=0; $i<$max; $i++) {
					print 'this.form.ID'.str_replace(":","",$DSNID[$i]).'.checked = false; ';					
				}
				print'"';if (isset($_POST["all"])){print ' checked';}print'> </td><td>all</td></tr>';
		for($i=0; $i<$max; $i++) {
			print '<tr><td><input name="ID'.str_replace(":","",$DSNID[$i]).'" type="checkbox" value="'.$DSNID[$i].'" '; if (isset($_POST["ID".str_replace(":","",$DSNID[$i])])){print 'checked';}print' onclick="this.form.all.checked = false;"></td><td> '.$DSNID[$i].'  </td><td>('.$ProgInfo[$i].')</td></tr>';
		}
		print'
		</table>
		</form>
		<hr/>';
	}
}
?>