<?php
//include("xmlrpc.inc");

include("properties.php");

list ($width_img, $height_img, $type, $attr) = getimagesize("Bild.jpg");
$radius = $GLOBALS['radius'];
$width_real = $GLOBALS['width_real'];
$height_real = $GLOBALS['height_real'];
$coninfoUpdate = $GLOBALS['coninfoUpdate'];
$offset_x = $GLOBALS['offset_x'];
$offset_y = $GLOBALS['offset_y'];


function arrow($im, $x1, $y1, $x2, $y2, $alength, $awidth, $color) {

	if ($y2 - $y1 == 0){$alpha = 0;}
	else if ($x2 - $x1 == 0){$alpha = M_PI/2;}
	else{
   		$alpha = atan (($y2 - $y1)/($x2 - $x1));
	}
	$ddy = sin($alpha) * $GLOBALS['radius'];
	$ddx = cos($alpha) * $GLOBALS['radius'];

	if ($x2-$x1 < 0){$ddx = -$ddx;}
	if ($y2-$y1 < 0){$ddy = -$ddy;}

	$x2 = $x2 - $ddx;
   	$y2 = $y2 - $ddy;
	
	$x1 = $x1 + $ddx;
	$y1 = $y1 + $ddy;

   	$distance = sqrt(pow($x1 - $x2, 2) + pow($y1 - $y2, 2));
	if($distance == 0){
		return;
	}

   	$dx = $x2 + ($x1 - $x2) * $alength / $distance;
   	$dy = $y2 + ($y1 - $y2) * $alength / $distance;

   	$k = $awidth / $alength;

   	$x2o = $x2 - $dx;
   	$y2o = $dy - $y2;

   	$x3 = $y2o * $k + $dx;
   	$y3 = $x2o * $k + $dy;

   	$x4 = $dx - $y2o * $k;
   	$y4 = $dy - $x2o * $k;

   	imageline($im, $x1, $y1, $dx, $dy, $color);
   	imageline($im, $x3, $y3, $x4, $y4, $color);
   	imageline($im, $x3, $y3, $x2, $y2, $color);
   	imageline($im, $x2, $y2, $x4, $y4, $color);
}

$lasttime = "";
$req = new xmlrpcmsg('getServerTime.getServerTime');
$resp = $c->send($req);
if(!$resp->faultCode()){
	$servertime = $resp->value()->scalarval();
	$lasttime = strtotime($servertime);
//	$ftime = strptime($servertime, '%Y-%m-%d %T');
//	$lasttime = mktime(                        
//		$ftime['tm_hour'],
//	        $ftime['tm_min'],
//	        $ftime['tm_sec'],
//	        1,
//	        $ftime['tm_yday'] + 1,
//	        $ftime['tm_year'] + 1900);
	$lasttime -= $GLOBALS['pingInterval'];
	$lasttime = date('Y-m-d H:i:s', $lasttime);	
	
}   

function isold_tf($lastseen){
	global $lasttime;
	if($lastseen < $lasttime){
		return(true);		
	}
	else {return(false);}
}

//$img_handle = ImageCreate ($width_img, $height_img) or die ("Cannot Create image");
$img_handle 	= imagecreatefromjpeg("Bild.jpg");
$color_white 	= ImageColorAllocate ($img_handle, 255, 255, 255);
$color_black 	= ImageColorAllocate ($img_handle, 0, 0, 0);
$color_red 		= ImageColorAllocate ($img_handle, 255, 0, 0);
imagestring($img_handle, 2, max(5,$width_img-125), 5, date("Y-m-d H:i:s"), $color_black);

$DSNIDtoNum = array();
$v=array();
$v[] = new xmlrpcval();

// draw the DSNLocation into the image
// XmlRpc Server
$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
// XmlRpc Function
$f=new xmlrpcmsg('getDSN.getDSN');
// send request
$r=&$c->send($f);

// check response for errors, and take appropriate action
// draw the dots into the image
if (!$r->faultCode()) {
  $v=$r->value();
  $max=$v->arraysize();
  for($i=0; $i<$max; $i++) {
  		// change the data from the XmlRpc-Request into new vars
		$rec=$v->arraymem($i);
		$DSNID_temp		  = $rec->structmem("DSNID");
		$DSNID[$i] 		  = $DSNID_temp->scalarval();
		$DSNVer_temp	  = $rec->structmem("DSNVer");
		$DSNVer[$i] 	  = $DSNVer_temp->scalarval();
		$DSNLocation_temp = $rec->structmem("DSNLocation");
		$DSNLocation[$i]  = $DSNLocation_temp->scalarval();
		$DSNProgInfo_temp = $rec->structmem("DSNProgInfo");
		$DSNProgInfo[$i]  = $DSNProgInfo_temp->scalarval();
		$DSNlastSeen_temp = $rec->structmem("DSNlastSeen");
		$DSNlastSeen[$i]  = $DSNlastSeen_temp->scalarval();
		// a hashtable to indicate the DSNId to the number $i (is used for drawing the conection arrows)
		$DSNIDtoNum[$DSNID[$i]] = $i;
		// parse the location string (xxx/yyy/zzz is espected)
		$firstbackslash = strpos($DSNLocation[$i],"/");
		$location = true;
		if ($firstbackslash != false) {$lastbackslash = strpos($DSNLocation[$i],"/",$firstbackslash+1);}
		if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_x[$i] = substr($DSNLocation[$i], 0,$firstbackslash);} else{$DSNLocation_x[$i] = 0;$location = false;}
		if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_y[$i] = substr($DSNLocation[$i], $firstbackslash+1,$lastbackslash-($firstbackslash+1));;} else{$DSNLocation_y[$i] = 0;}
		if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_z[$i] = substr($DSNLocation[$i], $lastbackslash+1, strlen($DSNLocation[$i])-($lastbackslash+1));;} else{$DSNLocation_z[$i] = 0;}
//echo "x: ".$DSNLocation_x[$i]."  y:".$DSNLocation_y[$i]."\n";
		if ($location){
			if(isold_tf($DSNlastSeen[$i])){
				ImageFilledEllipse($img_handle, ceil($DSNLocation_x[$i] * ($width_img / $width_real)), ceil($DSNLocation_y[$i] * ($height_img / $height_real)), 2*$radius, 2*$radius, $color_red );
				ImageString ($img_handle, 3, ceil($DSNLocation_x[$i] * ($width_img / $width_real)) + $radius, ceil($DSNLocation_y[$i] * ($height_img / $height_real)) + $radius, substr($DSNID[$i],strlen($DSNID[$i])-5,strlen($DSNID[$i])), $color_red );
			}
			else{
				ImageFilledEllipse($img_handle, ceil($DSNLocation_x[$i] * ($width_img / $width_real)), ceil($DSNLocation_y[$i] * ($height_img / $height_real)), 2*$radius, 2*$radius, $color_black );
				ImageString ($img_handle, 3, ceil($DSNLocation_x[$i] * ($width_img / $width_real)) + $radius, ceil($DSNLocation_y[$i] * ($height_img / $height_real)) + $radius, substr($DSNID[$i],strlen($DSNID[$i])-5,strlen($DSNID[$i])), $color_black );
			}
		}
  }
//  echo "width_img: ".$width_img."  width_real: ".$width_real."<br>";
//  echo "heigth_img: ".$height_img."  width_real: ".$height_real."<br>";
} else {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
}

// XmlRpc Function
$time_from = date('Y-m-d H:i:s',time()-$coninfoUpdate);
$time_till = date('Y-m-d H:i:s');

$f2=new xmlrpcmsg('getConinfo.getConinfo');
	$f2->addParam(new xmlrpcval("all"));
	$f2->addParam(new xmlrpcval("all"));
	$f2->addParam(new xmlrpcval("2"));
	$f2->addParam(new xmlrpcval((string)$time_from));
	$f2->addParam(new xmlrpcval((string)$time_till));

// send request
$r2=&$c->send($f2);

// check response for errors, and take appropriate action
if (!$r2->faultCode()) {
  $v2=$r2->value();
  $max_2=$v2->arraysize();
  for($i=0; $i<$max_2; $i++) {
		$rec=$v2->arraymem($i);
		$SourceAddr   		= $rec->structmem("SourceAddr");
		$SourceAddr_2[$i]	= $SourceAddr->scalarval();
		$NeighborAddr 		= $rec->structmem("NeighborAddr");
		$NeighborAddr_2[$i]	= $NeighborAddr->scalarval();
  }
} else {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
}

$f3=new xmlrpcmsg('getConinfo.getConinfo');
	$f3->addParam(new xmlrpcval("all"));
	$f3->addParam(new xmlrpcval("all"));
	$f3->addParam(new xmlrpcval("1"));
	$f3->addParam(new xmlrpcval((string)$time_from));
	$f3->addParam(new xmlrpcval((string)$time_till));

// send request
$r3=&$c->send($f3);

// check response for errors, and take appropriate action
if (!$r3->faultCode()) {
  $v3=$r3->value();
  $max_1=$v3->arraysize();
  for($i=0; $i<$max_1; $i++) {
		$rec=$v3->arraymem($i);
		$SourceAddr   				= $rec->structmem("SourceAddr");
		$SourceAddr_1[$i] 		= $SourceAddr->scalarval();
		$NeighborAddr 				= $rec->structmem("NeighborAddr");
		$NeighborAddr_1[$i]		= $NeighborAddr->scalarval();
  }
} else {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
}

// draw connection arrows
// if a node is meaning that he has a connection 
// to an other node which does not exist then draw
// a red arrow, normaly they are black.
for($i=0; $i<$max_1; $i++) {
	$check = false;
	for($j=0; $j<$max_2; $j++) {
		if (($SourceAddr_1[$i] == $NeighborAddr_2[$j])&&($SourceAddr_2[$j] == $NeighborAddr_1[$i])){$check = true;}
	}
	if ($check == true){
		arrow ($img_handle, ceil($DSNLocation_x[$DSNIDtoNum[$NeighborAddr_1[$i]]] * ($width_img / $width_real)), ceil($DSNLocation_y[$DSNIDtoNum[$NeighborAddr_1[$i]]] * ($height_img / $height_real)), ceil($DSNLocation_x[$DSNIDtoNum[$SourceAddr_1[$i]]] * ($width_img / $width_real)), ceil($DSNLocation_y[$DSNIDtoNum[$SourceAddr_1[$i]]] * ($height_img / $height_real)),8,3,$color_black);				
	}
	else{
		arrow ($img_handle, ceil($DSNLocation_x[$DSNIDtoNum[$NeighborAddr_1[$i]]] * ($width_img / $width_real)), ceil($DSNLocation_y[$DSNIDtoNum[$NeighborAddr_1[$i]]] * ($height_img / $height_real)), ceil($DSNLocation_x[$DSNIDtoNum[$SourceAddr_1[$i]]] * ($width_img / $width_real)), ceil($DSNLocation_y[$DSNIDtoNum[$SourceAddr_1[$i]]] * ($height_img / $height_real)),8,3,$color_red);				
	}	
}
for($i=0; $i<$max_2; $i++) {
	$check = false;
	for($j=0; $j<$max_1; $j++) {
		if (($SourceAddr_2[$i] == $NeighborAddr_1[$j])&&($SourceAddr_1[$j] == $NeighborAddr_2[$i])){$check = true;}
	}
	if ($check != true){
		arrow ($img_handle, ceil($DSNLocation_x[$DSNIDtoNum[$SourceAddr_2[$i]]] * ($width_img / $width_real)), ceil($DSNLocation_y[$DSNIDtoNum[$SourceAddr_2[$i]]] * ($height_img / $height_real)), ceil($DSNLocation_x[$DSNIDtoNum[$NeighborAddr_2[$i]]] * ($width_img / $width_real)), ceil($DSNLocation_y[$DSNIDtoNum[$NeighborAddr_2[$i]]] * ($height_img / $height_real)),8,3,$color_red);				
	}
}


//ImageJPEG ($img_white, "test_white.png");
$filename = "img/conimg_".date("YmdHis").".jpg";
ImageJPEG ($img_handle, $filename);
?> 
