<?php 
include "properties.php";

// default values
$form = array(
	'dsnid'		=> 'all',
	'timefrom'  => '0000-00-00 00:00:00',
	'timetil'   => '9999-12-31 00:00:00',
	'msg' 		=> '',
	'maxReply'  => '10');
	

if(isset($_POST['_send_test'])){
	foreach($_POST as $key => $value){
		$form[$key] = htmlentities($_POST[$key]);
	}
//		header ("Content-Type: application/vnd.ms-excel");
//		header("Expires: 0");
//		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
//		header("content-disposition: attachment;filename==yourFileName.xls");
 
	show_form();
	show_rpcs();
}
else{
	show_form();
}



function show_form(){
$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
$u=array();
$u[] = new xmlrpcval("1", "int");

$f=new xmlrpcmsg('getDSN.getDSN',$u);
// send request
$r=&$c->send($f);

// check response for errors, and take appropriate action
// draw the dots into the image
if (!$r->faultCode()) {
  $v=$r->value();
  $max=$v->arraysize();
  for($i=0; $i<$max; $i++) {
  		// change the data from the XmlRpc-Request into new vars
		$rec=$v->arraymem($i);
		$DSNID_temp		  = $rec->structmem("DSNID");
		$DSNID[$i] 		  = $DSNID_temp->scalarval();
  }
} else {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
}

?>
<hr/>
<form method="post" action="<?php echo $_SERVER['PHP_SELF']."?act=GetRPCS";?>">
<table> 
<tr><td>DSNID:</td><td>	<select name="dsnid">
	  <option><?php echo $GLOBALS['form']['dsnid'];?></option>
	  <option>all</option>
<?php
for($i=0; $i<$max; $i++) {
	print '	  <option>'.$DSNID[$i].'</option>';
}
?>
	</select>
</td></tr>
<tr><td>timefrom:</td><td><input type="text" name="timefrom" value="<?php echo $GLOBALS['form']['timefrom'];?>"/></td></tr>
<tr><td>timetill:</td><td><input type="text" name="timetil" value="<?php echo $GLOBALS['form']['timetil'];?>"/></td></tr>
<tr><td>msg:</td><td><input type="text" name="msg" value="<?php echo $GLOBALS['form']['msg'];?>"/></td></tr>
<tr><td>maxReply:</td><td>
	<select name="maxReply">
	  <option><?php echo $GLOBALS['form']['maxReply'];?></option>
	  <option>1</option>
	  <option>10</option>
	  <option>20</option>
	  <option>50</option>
	  <option>100</option>
	  <option>200</option>
	  <option>500</option>
	  <option>1000</option>
	</select>
</td></tr>
</table>
<input type="submit" value="get rpcs">
<input type="hidden" name="_send_test" value="1">
</form>
<hr/>
<?php

}


function show_rpcs(){
	// create client and message objects
	$v=array();
	$v[] = new xmlrpcval($GLOBALS['form']['dsnid'], "string"); // dsnid
	$v[] = new xmlrpcval($GLOBALS['form']['msg'], "string");  // msg
	$v[] = new xmlrpcval($GLOBALS['form']['timefrom'], "string");  // timefrom
	$v[] = new xmlrpcval($GLOBALS['form']['timetil'], "string");  // timetil
	$v[] = new xmlrpcval($GLOBALS['form']['maxReply'], "int");  // timetil

	
	$f=new xmlrpcmsg('getRPCS.getRPCS',  $v);
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	//$c->setDebug(2);

	// send request
	//print "<hr/><pre>".htmlentities($f->serialize())."</pre><hr/>\n";
	
	$r=&$c->send($f); 
	
	//print "<hr/><pre>".htmlentities($r->serialize())."</pre><hr/>\n";
	
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}
	else{
		$v = $r->value(); // array
		$max = $v->arraysize();
		if($max == 0){
			print "no logs found.\n";
			return;
		}
	?>
<style type="text/css">
	@import "getrpcs.css";
</style>

	  <table class="log">
	    <tr>
	      <th>DSNID</th><th>time</th><th>msg</th>
	    </tr>  	
	<?php
		for($i=0; $i < $max; $i++){
			$rec = $v->arraymem($i); // struct
			$dsnid_temp = $rec->structmem("DSNID");
			$dsnid = $dsnid_temp->scalarval();
			$time_temp = $rec->structmem("time");
			$time = $time_temp->scalarval();
			$text_temp = $rec->structmem("msg");
			$text = $text_temp->scalarval();
			print "<tr><td>".htmlspecialchars($dsnid).
			      "</td><td>".htmlspecialchars($time).
	              "</td><td>".htmlspecialchars($text).
			      "</td></tr>\n";
		}
		print "</table>\n";
	}
}
?>
