<?php
include "properties.php";
include "function_showimg.php";

function setlocation(){
	
	$width_real = $GLOBALS['width_real'];
	$height_real = $GLOBALS['height_real'];
	$offset_x = $GLOBALS['offset_x'];
	$offset_y = $GLOBALS['offset_y'];

	list ($width_img, $height_img, $type, $attr) = getimagesize("Bild.jpg");

	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$u=array();
	$u[] = new xmlrpcval("1", "int");

	$f=new xmlrpcmsg('getDSN.getDSN',$u);
	// send request
	$r=&$c->send($f);
	
	// check response for errors, and take appropriate action
	// draw the dots into the image
	if (!$r->faultCode()) {
	  $v=$r->value();
	  $max=$v->arraysize();
	  for($i=0; $i<$max; $i++) {
	  		// change the data from the XmlRpc-Request into new vars
			$rec=$v->arraymem($i);
			$DSNID_temp		  = $rec->structmem("DSNID");
			$DSNID[$i] 		  = $DSNID_temp->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}

	if (isset($_POST["_send_coordinat"])){
		// create client and message objects
		$location = $_POST["coordx"]."/".$_POST["coordy"]."/000";
		$v=array();
		$v[] = new xmlrpcval($_POST["dsnid"], "string"); 
		$v[] = new xmlrpcval($location, "string"); 
	
		$f=new xmlrpcmsg('setDSNLocation.setDSNLocation',  $v);
		$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
		$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
		//$c->setDebug(2);
		
		// send request
		//print "<hr/><pre>".htmlentities($f->serialize())."</pre><hr/>\n";
		
		$r=&$c->send($f); 
		
		//print "<hr/><pre>".htmlentities($r->serialize())."</pre><hr/>\n";
		
		if ($r->faultCode()) {
		  print "An error occurred:<pre>";
		  print "Code: " . htmlspecialchars($r->faultCode()) .
			"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
		}
	}


print'
	<script type="text/javascript">
	
		var Bild = document.images["Bild"];	
		
		function docjslib_getImageXfromLeft(imgID) {
		  if (NS4) return eval(imgID).x
		  else return docjslib_getRealLeft(imgID);
		}
		
		function docjslib_getImageYfromTop(imgID) {
		  if (NS4) return eval(imgID).y
		  else return docjslib_getRealTop(imgID);
		}
		
		function getRealLeft(imgElem) {
			xPos = eval(imgElem).offsetLeft;
			tempEl = eval(imgElem).offsetParent;
		  	while (tempEl != null) {
		  		xPos += tempEl.offsetLeft;
		  		tempEl = tempEl.offsetParent;
		  	}
			return xPos;
		}
		
		function getRealTop(imgElem) {
			yPos = eval(imgElem).offsetTop;
			tempEl = eval(imgElem).offsetParent;
			while (tempEl != null) {
		  		yPos += tempEl.offsetTop;
		  		tempEl = tempEl.offsetParent;
		  	}
			return yPos;
		}
		
		
		// Detect if the browser is IE or not.
		// If it is not IE, we assume that the browser is NS.
		var IE = document.all?true:false
		
		// If NS -- that is, !IE -- then set up for mouse capture
		if (!IE) document.captureEvents(Event.MOUSEMOVE)
		
		var tempX = 0
		var tempY = 0
		
		function getMouseXY(e) {
		  if (IE) { // grab the x-y pos.s if browser is IE
		    tempX = event.clientX + document.body.scrollLeft
		    tempY = event.clientY + document.body.scrollTop
		  } else {  // grab the x-y pos.s if browser is NS
		    tempX = e.pageX
		    tempY = e.pageY
		  }  
		  // catch possible negative values in NS4
		  if (tempX < 0){tempX = 0}
		  if (tempY < 0){tempY = 0}  
		  // show the position values in the form named form
		  // in the text fields named coordx and coordy
		  document.form.coordx.value = Math.round((tempX - getRealLeft(Bild))*('.($width_real/$width_img).'));
		  document.form.coordy.value = Math.round((tempY - getRealTop(Bild))*('.($height_real/$height_img).'));
		
		}
		
	</script>
';



	print'
	<hr/>
	<form method="post" name="form" action="'.$_SERVER["PHP_SELF"].'?act=SetLocation";">
	<table> 
	<tr><td>DSNID:</td><td>	<select name="dsnid">';
		if (isset($_POST["_send_coordinat"])){print'<option>'.$_POST['dsnid'].'</option>';}else{print'<option> </option>';}
	for($i=0; $i<$max; $i++) {
		print '	  <option>'.$DSNID[$i].'</option>';
	}	
	print'
	</select>
	</td></tr>
	<tr><td>x:</td><td><input type="text" size="4" name="coordx" '; if (isset($_POST["_send_coordinat"])){print'value="'.$_POST['coordx'].'"';} print' /></td></tr>
	<tr><td>y:</td><td><input type="text" size="4" name="coordy" '; if (isset($_POST["_send_coordinat"])){print'value="'.$_POST['coordy'].'"';} print' /></td></tr>
	</table>
	<input type="submit" value="set Location">
	<input type="hidden" name="_send_coordinat" value="1">
	</form>
	<hr/>';


}			

showimg();

$dir = "img/";
$d = dir($dir);

$comparedatestr="1970-01-01 00:00:00";
$comparedate=strtotime($comparedatestr);
	
while (false !== ($entry = $d->read())) {
	if($entry!='.' && $entry!='..' && is_file($dir.'/'.$entry)) {
       $fulldir=$dir.'/'.$entry;
       $last_modified = filemtime($fulldir);
       $last_modified_str= date("Y-m-d H:i:s", $last_modified);

           if($comparedate < $last_modified)  {
             $comparedate = $last_modified;
             $filename = $dir.'/'.$entry;
           }
	}
}
$d->close(); 

print'
<style type="text/css">
	@import "showimg.css";
</style>

<img src="'.$filename.'" usemap="menu" border="0" onclick="getMouseXY(event)" name="Bild"></img>

';

setlocation();

?>
